define([
    "dojo/_base/declare",
    "thornberry/app/Component/_EditorComponent",
    "thornberry/app/Component/_TableFieldEditorMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/aspect",
    "dojo/text!./Templates/AdjustmentEditor.html",
    "dijit/form/ValidationTextBox",
    "dijit/form/RadioButton",
    "dijit/form/DateTextBox",
    "dijit/form/Form",
    "dijit/form/FilteringSelect",
    "dijit/form/Select",
    "dijit/form/NumberSpinner"
],function(
    declare,
    _EditorComponent,
    _TableFieldEditorMixin,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    lang,
    arrayUtils,
    aspect,
    template
) {
    return declare([_EditorComponent,_TemplatedMixin,_WidgetsInTemplateMixin,_TableFieldEditorMixin], {
        templateString: template,

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                mode: "add",
                value: null,
                disabled: true,
                onCancel: null,
                onApply: null
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);

            t.addRequirement(null,true);
        },

        postCreate: function() {
            var t = this;
            t.inherited(arguments);

            // Clear fields when they become disabled automatically
            arrayUtils.forEach(t.fields,function(field) {
                t.own(aspect.after(field,"_setDisabledAttr",function(value) {
                    if (value) {
                        t.setFormValue(field.name,null,true);
                    }
                },true));
            });
        },

        postscript: function() {
            var t = this;
            t.inherited(arguments);
            t.set("value",t.props.value);
        },

        _onCancel: function() {
            var t = this;
            if (t.props.onCancel) {
                t.props.onCancel();
            }
        },

        _onApply: function() {
            var t = this;
            if (t.props.onApply) {
                t.props.onApply();
            }
        },

        _onReset: function() {
            var t = this;
            t.invalidateRendering();
        },

        onChangeModified: function(value) {
            var t = this;
            t.applyButton.set("disabled",!value);
            t.resetButton.set("disabled",!value);
        }
    });
});